SystemOrganization addCategory: #'Pier-Documentation'!

ReadWriteStream subclass: #PRLatexStream
	instanceVariableNames: ''
	classVariableNames: 'LatexCharacters'
	poolDictionaries: ''
	category: 'Pier-Documentation'!

!PRLatexStream class methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
initialize
	LatexCharacters := Dictionary new.
	LatexCharacters
		at: $# put: '\#';
		at: $& put: '\&';
		at: $% put: '\%';
		at: $$ put: '\$';
		at: ${ put: '\{';
		at: $} put: '\}';
		at: $" put: '\symbol{34}';
		" -- "
		at: $[ put: '{[}';
		at: $] put: '{]}';
		at: $| put: '$|$';
		at: $< put: '$<$';
		at: $> put: '$>$';
		at: $/ put: '$/$';
		at: $\ put: '$\backslash$';
		at: $_ put: '$\leftarrow$';
		at: $^ put: '$\uparrow$';
		" -- "
		at: $ put: '\"{a}';
		at: $ put: '\"{A}';
		at: $ put: '\"{e}';
		at: $ put: '\"{E}';
		at: $ put: '\"{i}';
		at: $ put: '\"{I}';
		at: $ put: '\"{o}';
		at: $ put: '\"{O}';
		at: $ put: '\"{u}';
		at: $ put: '\"{U}';
		at: $ put: '\"{y}';
		at: $ put: '\"{Y}';
		" -- "
		at: $ put: '\^{a}';
		at: $ put: '\^{A}';
		at: $ put: '\^{e}';
		at: $ put: '\^{E}';
		at: $ put: '\^{i}';
		at: $ put: '\^{I}';
		at: $ put: '\^{o}';
		at: $ put: '\^{O}';
		at: $ put: '\^{u}';
		at: $ put: '\^{U}';
		" -- "
		at: $ put: '\`{a}';
		at: $ put: '\`{A}';
		at: $ put: '\`{e}';
		at: $ put: '\`{E}';
		at: $ put: '\`{i}';
		at: $ put: '\`{I}';
		at: $ put: '\`{o}';
		at: $ put: '\`{O}';
		at: $ put: '\`{u}';
		at: $ put: '\`{U}';
		" -- "
		at: $ put: '\''{a}';
		at: $ put: '\''{A}';
		at: $ put: '\''{e}';
		at: $ put: '\''{i}';
		at: $ put: '\''{I}';
		at: $ put: '\''{o}';
		at: $ put: '\''{O}';
		at: $ put: '\''{u}';
		at: $ put: '\''{U}';
		" -- "
		at: $ put: '\c{c}';
		at: $ put: '\c{C}';
		" -- "
		at: $~ put: '\~{}';
		at: $ put: '\~{n}';
		at: $ put: '\~{N}'! !

!PRLatexStream methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
basicPutAll: aString
	super nextPutAll: aString! !

!PRLatexStream methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
basicPut: aCharacter
	super nextPut: aCharacter! !

!PRLatexStream methodsFor: 'conveniance' stamp: 'lr 3/9/2006 11:29'!
comment: anObject
	self basicPut: $%; space; basicPutAll: anObject asString; cr! !

!PRLatexStream methodsFor: 'streaming' stamp: 'lr 3/9/2006 11:29'!
cr
	(position isZero
		or: [ position > 1
		and: [ (collection at: position) = Character cr
		and: [ (collection at: position - 1) = Character cr ] ] ])
			ifTrue: [ ^ self ].
	super cr! !

!PRLatexStream methodsFor: 'conveniance' stamp: 'lr 3/9/2006 11:29'!
curly: anObject
	self basicPut: ${; print: anObject; basicPut: $}! !

!PRLatexStream methodsFor: 'conveniance' stamp: 'lr 3/9/2006 11:29'!
environment: aString do: anObject
	self tag: 'begin'; curly: aString; cr.
	self print: anObject.
	self tag: 'end'; curly: aString; cr! !

!PRLatexStream methodsFor: 'streaming' stamp: 'lr 3/9/2006 11:29'!
nextPutAll: anObject
	anObject asString do: [ :each | self nextPut: each ]! !

!PRLatexStream methodsFor: 'streaming' stamp: 'lr 5/17/2006 14:59'!
nextPutClose: anObject
	anObject asString do: [ :each | 
		Character space = each
			ifTrue: [ self basicPut: $~ ]
			ifFalse: [ self nextPut: each ] ]! !

!PRLatexStream methodsFor: 'streaming' stamp: 'lr 3/9/2006 11:29'!
nextPut: aCharacter
	| string |
	string := LatexCharacters at: aCharacter ifAbsent: nil.
	string isNil
		ifTrue: [ self basicPut: aCharacter ]
		ifFalse: [ self basicPutAll: string ]! !

!PRLatexStream methodsFor: 'initialization' stamp: 'lr 5/17/2006 13:59'!
on: aCollection
	super on: aCollection.
	self
		comment: '$Id:$';
		comment: SystemVersion current asString;
		comment: TimeStamp now asString;
		cr;
		comment: 'This is an automatically generated file, do not modify manually!!';
		cr;
		cr! !

!PRLatexStream methodsFor: 'streaming' stamp: 'lr 3/9/2006 11:29'!
print: anObject
	anObject printLatexOn: self! !

!PRLatexStream methodsFor: 'conveniance' stamp: 'lr 3/9/2006 11:29'!
square: anObject
	self basicPut: $[; print: anObject; basicPut: $]! !

!PRLatexStream methodsFor: 'conveniance' stamp: 'lr 3/9/2006 11:29'!
tag: aString
	self basicPut: $\; basicPutAll: aString! !

!UndefinedObject methodsFor: '*pier-documentation-printing' stamp: 'lr 3/9/2006 11:29'!
printLatexOn: aStream! !

!String methodsFor: '*pier-documentation' stamp: 'lr 5/22/2006 16:45'!
hyphenate
	^ String streamContents: [ :stream |
		stream nextPut: self first.
		self reduce: [ :a :b |
			(a isLowercase and: [ b isUppercase ])
				ifTrue: [ stream nextPutAll: '\-' ].
			stream nextPut: b ] ]! !

!Object methodsFor: '*pier-documentation-printing' stamp: 'lr 3/9/2006 11:29'!
printLatexOn: aStream
	aStream nextPutAll: self displayString! !

Object subclass: #PRLatexBuilder
	instanceVariableNames: 'packages directory name stream classes categories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Documentation'!

!PRLatexBuilder class methodsFor: 'building' stamp: 'lr 5/22/2006 08:06'!
build: aCollection in: aDirectory named: aString
	^ self new
		setPackages: aCollection;
		setDirectory: aDirectory;
		setName: aString;
		build! !

!PRLatexBuilder class methodsFor: 'accessing' stamp: 'lr 5/5/2006 18:31'!
directory
	^ FileDirectory default directoryNamed: 'docs'! !

!PRLatexBuilder class methodsFor: 'accessing' stamp: 'lr 5/17/2006 21:21'!
packages
	^ #( 'Magritte-Model' 'Pier-Model' )
		collect: [ :each | PackageInfo named: each ]! !

!PRLatexBuilder methodsFor: 'building' stamp: 'lr 5/22/2006 09:08'!
build
	| output |
	stream := PRLatexStream on: String new.
	stream tag: 'chapter'; curly: [
		stream 
			nextPutAll: 'Documentation';
			tag: 'label'; curly: 'cha:documentation' ];
		cr.
	self packages do: [ :each | self buildPackage: each ].
	output := self directory forceNewFileNamed: self name.
	[ output nextPutAll: stream contents ] ensure: [ output close ]! !

!PRLatexBuilder methodsFor: 'building-tools' stamp: 'lr 5/22/2006 17:11'!
buildClassEnum: aCollection labelled: aString on: aStream
	aCollection isEmpty ifTrue: [ ^ self ].
	aStream tag: 'paragraph'; curly: aString; cr.
	aCollection
		do: [ :each | 
			(classes includes: each)
				ifFalse: [ aStream basicPutAll: each name hyphenate ]
				ifTrue: [ 
					aStream tag: 'hyperref'; square: each name; curly: [
						aStream basicPutAll: each name hyphenate ] ] ]
		separatedBy: [ aStream nextPutAll: ', ' ].
	aStream cr; cr! !

!PRLatexBuilder methodsFor: 'building' stamp: 'lr 5/22/2006 17:05'!
buildPackage: aPackage
	classes := (aPackage classes select: [ :each | each hasComment ])
		asSet.
	categories := (classes collect: [ :each | each category ])
		asSet.
	classes isEmpty ifFalse: [
		stream tag: 'section*'; curly: aPackage packageName; cr.
		stream tag: 'addcontentsline'; curly: 'toc'; curly: 'section'; curly: aPackage packageName; cr.
		aPackage systemCategories
			do: [ :each |
				(categories includes: each)
					ifTrue: [ self buildPackage: aPackage category: each ] ]
			displayingProgress: aPackage packageName.
		stream cr; cr ]! !

!PRLatexBuilder methodsFor: 'building' stamp: 'lr 5/22/2006 17:08'!
buildPackage: aPackage category: aSymbol
	stream tag: 'subsection*'; curly: aSymbol; cr.
	stream tag: 'addcontentsline'; curly: 'toc'; curly: 'subsection'; curly: aSymbol; cr.
	((classes
		select: [ :each | each category = aSymbol ])
		asSortedCollection: [ :a :b | a asNode sortsBefore: b asNode ])
		do: [ :each | self buildPackage: aPackage class: each ]! !

!PRLatexBuilder methodsFor: 'building' stamp: 'lr 5/22/2006 16:26'!
buildPackage: aPackage class: aClass 
	stream tag: 'subsubsection*'; curly: [
		stream
			print: aClass name;
			tag: 'label'; curly: aClass name;
			tag: 'index'; curly: (aClass name allButFirst: 2) ];
		cr.
	self
		buildClassEnum: aClass allSuperclasses allButLast reverse
		labelled: 'Superclasses' on: stream.
	self
		buildClassEnum: ((aClass allSubclasses
			select: [ :each | aPackage includesClass: each ])
			asSortedCollection: [ :a :b | a name <= b name ])
		labelled: 'Subclasses' on: stream.
	self wiki: aClass organization classComment offset: 5.
	(aPackage coreCategoriesForClass: aClass) asSortedCollection
		do: [ :each | self buildPackage: aPackage class: aClass category: each ]! !

!PRLatexBuilder methodsFor: 'building' stamp: 'lr 5/22/2006 16:26'!
buildPackage: aPackage class: aClass category: aString
	(Categorizer allCategory = aString
		or: [ Categorizer nullCategory = aString ]
		or: [ aString beginsWith: 'private' ])
			ifTrue: [ ^ self ].
	((aPackage methodsInCategory: aString ofClass: aClass)
		allSatisfy: [ :each | (aClass firstPrecodeCommentFor: each methodSymbol) isEmptyOrNil ])
			ifTrue: [ ^ self ].
	stream tag: 'subsubsection*'; curly: aString; cr.
	stream environment: 'itemize' do: [
		(aPackage methodsInCategory: aString ofClass: aClass) asSortedCollection
			do: [ :each | self buildPackage: aPackage class: aClass category: aString selector: each methodSymbol ] ].
	stream cr; cr
! !

!PRLatexBuilder methodsFor: 'building' stamp: 'lr 5/22/2006 16:26'!
buildPackage: aPackage class: aClass category: aString selector: aSelector
	| source |
	source := aClass firstPrecodeCommentFor: aSelector.
	source isEmptyOrNil ifTrue: [ ^ self ].
	stream 
		tag: 'item'; 
		tag: 'index'; curly: aSelector;
		tag: 'code'; curly: [
			stream nextPutAll: aClass name; nextPutAll: '>>'; nextPutClose: (aClass methodHeaderFor: aSelector) ];
		basicPutAll: ' \\'; cr.
	self wiki: source offset: 6! !

!PRLatexBuilder methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
directory
	^ directory! !

!PRLatexBuilder methodsFor: 'accessing' stamp: 'lr 5/22/2006 08:06'!
name
	^ name! !

!PRLatexBuilder methodsFor: 'accessing' stamp: 'lr 5/22/2006 08:07'!
packages
	^ packages! !

!PRLatexBuilder methodsFor: 'initialization' stamp: 'lr 5/5/2006 18:30'!
setDirectory: aDirectory
	directory := aDirectory assureExistence! !

!PRLatexBuilder methodsFor: 'initialization' stamp: 'lr 5/22/2006 08:05'!
setName: aString
	name := aString! !

!PRLatexBuilder methodsFor: 'initialization' stamp: 'lr 5/22/2006 08:06'!
setPackages: aCollection
	packages := aCollection! !

!PRLatexBuilder methodsFor: 'private' stamp: 'lr 5/22/2006 09:11'!
wiki: aString offset: anInteger
	PRLatexWriter
		format: (PRDocumentParser parse: (aString ifNil: [ String new ]))
		offset: anInteger on: stream.
	stream cr; cr! !

!BlockContext methodsFor: '*pier-documentation-printing' stamp: 'lr 3/9/2006 11:29'!
printLatexOn: aStream
	self numArgs = 0
		ifTrue: [ self value ]
		ifFalse: [ self value: aStream ]! !

PRVisitor subclass: #PRLatexWriter
	instanceVariableNames: 'stream offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Documentation'!

!PRLatexWriter class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:29'!
format: aDocument offset: anInteger on: aStream
	^ self new
		setOffset: anInteger;
		setStream: aStream;
		visit: aDocument;
		contents! !

!PRLatexWriter methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
contents
	^ self stream contents! !

!PRLatexWriter methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
offset
	^ offset! !

!PRLatexWriter methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:29'!
sectionForLevel: anInteger
	^ #( 'part' 'chapter' 'section' 'subsection' 'subsubsection' 'paragraph' )
			at: self offset + anInteger ifAbsent: 'subparagraph'! !

!PRLatexWriter methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setOffset: anInteger
	offset := anInteger! !

!PRLatexWriter methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setStream: aStream
	stream := aStream! !

!PRLatexWriter methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
stream
	^ stream! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitAnchor: anObject
	self stream tag: 'label'; curly: anObject name; cr! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitExternalLink: anObject
	self stream
		tag: 'href';
		curly: [ self stream basicPutAll: anObject url ];
		curly: [ super visitExternalLink: anObject ]! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitHeader: anObject
	self stream tag: (self sectionForLevel: anObject level); curly: anObject text; cr! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/22/2006 16:05'!
visitInternalLink: anObject
	self stream
		tag: 'hyperref';
		square: [ self stream basicPutAll: anObject reference ];
		curly: [ super visitInternalLink: anObject ]! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitLink: anObject
	anObject hasChildren
		ifTrue: [ super visitLink: anObject ]
		ifFalse: [ self stream print: anObject reference ]! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitListItem: anObject
	self stream tag: 'item'; space.
	super visitListItem: anObject.
	self stream cr! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitOrderedList: anObject
	self stream environment: 'enumerate' do: [ super visitOrderedList: anObject ]! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitParagraph: anObject
	super visitParagraph: anObject.
	self stream cr; cr! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitPreformatted: anObject
	self stream environment: 'source' do: [
		anObject children do: [ :each |
			self stream basicPutAll: each text; cr ] ]! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitTableRow: aTableRow
	self visitAll: aTableRow children separatedBy: [ self stream basicPut: $& ]! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitTable: anObject
	self stream environment: 'tabular' do: [
		self stream curly: (String new: anObject columnCount withAll: $l); cr.
		self visitAll: anObject children separatedBy: [ self stream basicPutAll: '\\'; cr ] ]! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitText: anObject
	| text |
	text := anObject text readStream.
	[ text atEnd ] whileFalse: [
		self stream nextPutAll: (text upTo: $<).
		text atEnd ifFalse: [
			self stream
				tag: (text upTo: $>);
				curly: (text upTo: $<).
			text upTo: $> ] ]! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitUnorderedList: anObject
	self stream environment: 'itemize' do: [ super visitUnorderedList: anObject ]! !
PRLatexStream initialize!
